#include <bits/stdc++.h>
#define int long long
using namespace std;
int n,k,t;
vector<int>a;
signed main()
{
cin>>t>>n>>k;
a.resize(n);
for(int i = 0;i<n;i++)
cin>>a[i];
sort(a.begin(),a.end());
bool ai=true;
for(int i = 0;i<n;i++)
if(a[i]!=i+1)
ai=false;
if(ai){
if(k<0)
cout<<"NE"<<endl;
else{
int x=(n-k)/2;
if(abs(n-k)%2==1)
cout<<"NE"<<endl;
else{
int poz=k+x;
int neg=x;
if(poz>=neg&&poz>=0&&neg>=0){
if(x+1>=1){
cout<<"DA"<<endl;
if(t==1){
for(int i = x+1;i<=n;i++)
cout<<i<<" ";
for(int i = x;i>=1;i--)
cout<<i<<" ";
cout<<endl;

}

}
else
cout<<"NE"<<endl;
}
else
cout<<"NE"<<endl;

}}







}
else{
int curr=0;
for(int i = 0;i<n;i++){
if(a[i]>=curr)curr++;
else
curr--;
}
if(curr==k){
cout<<"DA"<<endl;
if(t==1)
for(int i = 0;i<n;i++)
cout<<a[i]<<" ";
}
else
cout<<"NE"<<endl;

}


    return 0;
}